; Source created with Parsic Version 3.x

; at              : 14/08/02 19.19.51


; Project File    : c:\PROGRA~1\PARSIC\PWM\LIMITER1.PIC

; Project Version : 1.0.11

; Created         : 22/01/02 21.08.00

; Last change     : 14/08/02 19.19.34

	PROCESSOR 16C715

	INCLUDE P16C715.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_ON & _BODEN_ON & _XT_OSC & _MPEEN_OFF

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

SYS_WSAV	= 32	; located in Bank 0
SYS_TMP1	= 33	; located in Bank 0
SYS_SSAV	= 34	; located in Bank 0
S0	= 43	; located in Bank 0
S1	= 44	; located in Bank 0
ADC0	= 45	; located in Bank 0
OS1_FD	= 46	; located in Bank 0
OS2_FD	= 47	; located in Bank 0
MF1	= 48	; located in Bank 0
MF1_HI	= 49	; located in Bank 0
RAM	= 50	; located in Bank 0
SYS_WSAV2	= 160	; located in Bank 1

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV

	BCF INTCON,T0IF	; Interrupt quitieren

	BCF STATUS,RP0	; Bank 0
	INCFSZ MF1,F
	GOTO SYS_INT_LABEL_0
	INCF MF1_HI,F

SYS_INT_LABEL_0

EXITINT

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE


;****************************************
; Subroutines
;****************************************

;***************************************************
; Read  -> AN0
;***************************************************

READ_AN0
	BSF STATUS,RP0	; Bank 1
	BCF ADCON1,0
	BSF TRISA,0
	MOVLW B'11000001'	; CH0
	BCF STATUS,RP0	; Bank 0
	MOVWF ADCON0
	MOVLW 5
	MOVWF SYS_TMP1

SYS_ADC_LABEL_0
	DECFSZ SYS_TMP1,F
	GOTO SYS_ADC_LABEL_0

	BSF ADCON0,GO	; Wandlung starten

SYS_ADC_LABEL_1

	BTFSC ADCON0,GO	; Schon fertig ?
	GOTO SYS_ADC_LABEL_1	; Sprung, wenn nicht

	MOVFW ADRES	; Wert holen
	MOVWF ADC0	; und speichern

	MOVLW 3
	BSF STATUS,RP0	; Bank 1
	MOVWF ADCON1
	MOVLW B'11111111'
	MOVWF TRISA
	RETURN


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000001'
	MOVWF PORTB

	MOVLW 143
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG

	MOVLW 3	; all digital
	MOVWF ADCON1

; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'11110000'
	MOVWF TRISB

; init vars


; Clear RAM

	MOVLW 32
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	BTFSS FSR,7
	GOTO CR1
	BSF FSR,5
CR2
	CLRF INDF
	INCF FSR,F
	BTFSS FSR,6
	GOTO CR2


	BCF STATUS,RP0	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

	CALL READ_AN0
;***************************************************
; Limiter -> LM1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF S1,0
	BCF S1,1
	MOVFW ADC0
	MOVWF S0
	MOVLW 200
	SUBWF S0,W
	BTFSS STATUS,CARRY
	GOTO LABEL_LM1_BOTTOM
	BTFSC STATUS,ZERO
	GOTO LABEL_LM1_BOTTOM
	BSF S1,0
	MOVLW 200
	MOVWF S0
	GOTO LABEL_LM1_EXIT
LABEL_LM1_BOTTOM
	MOVLW 50
	SUBWF S0,W
	BTFSC STATUS,CARRY
	GOTO LABEL_LM1_EXIT
	BSF S1,1
	MOVLW 50
	MOVWF S0
LABEL_LM1_EXIT

;***************************************************
; Schmitt-Trigger 8-Bit -> ST1
;***************************************************

	BTFSS PORTB,0	; Ausgang gesetzt ?
	GOTO LABEL_ST1_MH	; dann mit Hysterese ?

	MOVLW 150
	GOTO LABEL_ST1_TEST

LABEL_ST1_MH

	MOVLW 130
LABEL_ST1_TEST

	SUBWF S0,W
	BTFSS STATUS,CARRY
	GOTO LABEL_ST1_RESET

	BCF PORTB,0	; if greater or equal
	GOTO LABEL_ST1_ENDE

LABEL_ST1_RESET
	BSF PORTB,0	; if less
LABEL_ST1_ENDE

;***************************************************
; One Shot -> OS1
;***************************************************


	BTFSS S1,0
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S1,2
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF STATUS,RP0	; Bank 0
	BCF S1,2
	BTFSC S1,0
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;***************************************************
; One Shot -> OS2
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BTFSS S1,1
	GOTO LABEL_OS2_1
	BTFSC OS2_FD,0
	GOTO LABEL_OS2_1
	BSF OS2_FD,0
	BSF S1,3
	GOTO LABEL_OS2_2
LABEL_OS2_1
	BCF STATUS,RP0	; Bank 0
	BCF S1,3
	BTFSC S1,1
	GOTO LABEL_OS2_2
	BCF OS2_FD,0
LABEL_OS2_2
;***************************************************
; RS-FLIP-FLOP -> RS1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BTFSC S1,5
	GOTO LABEL_RS1_RESET
	BTFSS S1,2
	GOTO LABEL_RS1_ENDE
	BSF PORTB,1	; Ausgang setzen
	GOTO LABEL_RS1_ENDE
LABEL_RS1_RESET
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,1	; Ausgang zurcksetzen
LABEL_RS1_ENDE

;***************************************************
; RS-FLIP-FLOP -> RS2
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BTFSC S1,5
	GOTO LABEL_RS2_RESET
	BTFSS S1,3
	GOTO LABEL_RS2_ENDE
	BSF PORTB,2	; Ausgang setzen
	GOTO LABEL_RS2_ENDE
LABEL_RS2_RESET
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,2	; Ausgang zurcksetzen
LABEL_RS2_ENDE

;***************************************************
; ODER - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BCF STATUS,RP0	; Bank 0
	BTFSC S1,2
	GOTO LABEL_LG1_TRUE
LABEL_LG1_2
	BTFSC S1,3
	GOTO LABEL_LG1_TRUE

LABEL_LG1_FALSE
	BCF S1,4
	GOTO LABEL_LG1_ENDE
LABEL_LG1_TRUE
	BCF STATUS,RP0	; Bank 0
	BSF S1,4
LABEL_LG1_ENDE
;***************************************************
; RS-FLIP-FLOP -> RS3
;***************************************************

	BTFSC S1,5
	GOTO LABEL_RS3_RESET
	BTFSS S1,4
	GOTO LABEL_RS3_ENDE
	BSF PORTB,3	; Ausgang setzen
	GOTO LABEL_RS3_ENDE
LABEL_RS3_RESET
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,3	; Ausgang zurcksetzen
LABEL_RS3_ENDE

;***************************************************
; Anzug-Verzgerung -> MF1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BTFSC PORTB,7	; Eingang auf High ?
	GOTO LABEL_MF1_CHKTIME	; Ja

; RESET

	CLRF MF1
	CLRF MF1_HI
	BCF S1,5
	GOTO LABEL_MF1_EXIT	; raus

LABEL_MF1_CHKTIME

	BCF STATUS,RP0	; Bank 0
	BTFSC S1,5	; Ausgang schon auf High ?
	GOTO LABEL_MF1_EXIT	; Ja

	MOVLW 0
	SUBWF MF1_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	MOVLW 78
	SUBWF MF1,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	BSF S1,5
LABEL_MF1_EXIT

;****************************************

	GOTO MAIN


	END

